import { ICircuitRelay } from '../pb/index.js';
import { StreamHandler } from './stream-handler.js';
import type { Connection } from '@libp2p/interfaces/connection';
import type { Duplex } from 'it-stream-types';
export interface HandleStopOptions {
    connection: Connection;
    request: ICircuitRelay;
    streamHandler: StreamHandler;
}
/**
 * Handles incoming STOP requests
 */
export declare function handleStop(options: HandleStopOptions): Duplex<Uint8Array> | undefined;
export interface StopOptions {
    connection: Connection;
    request: ICircuitRelay;
}
/**
 * Creates a STOP request
 */
export declare function stop(options: StopOptions): Promise<Duplex<Uint8Array, Uint8Array, Promise<void>> | undefined>;
//# sourceMappingURL=stop.d.ts.map