import 'node-forge/lib/x509.js';
/**
 * Gets a self-signed X.509 certificate for the key.
 *
 * The output Uint8Array contains the PKCS #7 message in DER.
 *
 * TODO: move to libp2p-crypto package
 */
export declare const certificateForKey: (key: any, privateKey: any) => any;
/**
 * Finds the first item in a collection that is matched in the
 * `asyncCompare` function.
 *
 * `asyncCompare` is an async function that must
 * resolve to either `true` or `false`.
 *
 * @param {Array} array
 * @param {function(*)} asyncCompare - An async function that returns a boolean
 */
export declare function findAsync<T>(array: T[], asyncCompare: (val: T) => Promise<any>): Promise<T>;
//# sourceMappingURL=util.d.ts.map